%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Test Golden Vectors
% XX November 2006, Release 0.9
%
% Comments: This function checks against know set of Golden Vectors
%
% Input:
%
% Output:
%
% Internal Variables:
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load GoldCheck % load CM5 FullVectors which are Golden

% reassign vectors
AoaWrappedVector_1=AoaWrappedVector;
InsPowVector_1=InsPowVector;
ToaVector_1=ToaVector;

clear AoaWrappedVector InsPowVector ToaVector

cd('CM5') % nothing special about CM5, just picked it
load FullVectors
cd ..

% reassign vectors
AoaWrappedVector_2=AoaWrappedVector;
InsPowVector_2=InsPowVector;
ToaVector_2=ToaVector;

clear AoaWrappedVector InsPowVector ToaVector

% check to make sure both set of vectors have the same dimension
SizeDelta=sum(size(AoaWrappedVector_1))+sum(size(InsPowVector_1))+sum(size(ToaVector_1))-...
    sum(size(AoaWrappedVector_2))-sum(size(InsPowVector_2))-sum(size(ToaVector_2));

disp(' '); disp('*******************************************************')

if SizeDelta~=0
    
    disp('Golden Cluster Check Failed')
    disp('For some reason, you are not generating Golden Clusters')
    disp('- contact Rick Roberts at richard.d.roberts@intel.com for a CDROM')

else
    
    % subtract the vectors
    AoaWrappedVectorDelta=AoaWrappedVector_2-AoaWrappedVector_1;
    InsPowVectorDelta=InsPowVector_2-InsPowVector_2;
    ToaVectorDelta=ToaVector_2-ToaVector_1;

    % sum up the elements
    AoaWrappedVectorSum=sum(sum(AoaWrappedVectorDelta));
    InsPowVectorSum=sum(sum(InsPowVectorDelta));
    ToaVectorSum=sum(sum(ToaVectorDelta));
    tSum=AoaWrappedVectorSum+InsPowVectorSum+ToaVectorSum;

    if tSum~=0 % tSum should have a value of zero if we are Golden
    
        disp('Golden Cluster Check Failed')
        disp('For some reason, you are not generating Golden Clusters')
        disp('- contact Rick Roberts at richard.d.roberts@intel.com for a CDROM')
        
    else

        disp('Golden Cluster Check Passed!')
        disp('Congratulations ... you are generating Golden Clusters!')
        
    end

end

disp('*******************************************************')
